<template>
  <div
    ref="el"
    class="map-libre">
    <slot
      v-if="load" />
  </div>
</template>

<script>
import { propsMap } from './shared/props.js'

export const opts = propsMap
</script>

<script setup>
import { ref, reactive, computed, watch, onMounted, onUnmounted, provide } from 'vue'
import { Map } from 'maplibre-gl'
import { eventsMapEmit, eventsMap } from './shared/events.js'
import { defineHandlers, removeHandlers } from '@/shared/events.js'
import { setOptions } from './shared/options.js'
import { setLang } from './shared/lang.js'
import 'maplibre-gl/dist/maplibre-gl.css'

// events
// other events are declared from attrs
const emit = defineEmits(eventsMapEmit)

// props
const props = defineProps(opts)

// data
const el = ref(null)
const map = ref(null)
const load = ref(false)

// computed
const container = computed(() => {
  if (props.container) return props.container
  return el.value
})

// options to init map
const options = computed(() => {
  const o = setOptions(props)
  o.container = container.value
  if (o.tiles) o.style = o.tiles
  // remove custom props
  delete o.tiles
  delete o.padding
  delete o.animation
  return o
})

// camera state
const camera = reactive({
  center: props.center,
  zoom: props.zoom,
  pitch: props.pitch,
  bearing: props.bearing,
  padding: props.padding
})

// watch camera related props to trigger the watch camera
watch(() => props.center, val => { camera.center = val })
watch(() => props.zoom, val => { camera.zoom = val })
watch(() => props.pitch, val => { camera.pitch = val })
watch(() => props.bearing, val => { camera.bearing = val })
watch(() => props.padding, val => { camera.padding = val })

// 'moveend' is triggered every time an easeTo is interupted
// so this timeout allow us to update camera position
// only when a transition is done and cancel an ongoing one
let timeout = undefined
const change = (cb, delay) => {
  if (timeout) clearTimeout(timeout)
  timeout = null
  if (cb && delay) timeout = setTimeout(cb, delay)
  else if (cb) cb()
}

// method called to update internal camera state
// and emit props changes
const updateCamera = () => {
  camera.center = map.value.getCenter().toArray()
  camera.zoom = map.value.getZoom()
  camera.pitch = map.value.getPitch()
  camera.bearing = map.value.getBearing()
  emit('update:center', camera.center)
  emit('update:zoom', camera.zoom)
  emit('update:pitch', camera.pitch)
  emit('update:bearing', camera.bearing)
  emit('change', map.value)
}

// move from camera prop change
watch(camera, val => {
  if (map.value) {
    // cancel any ongoing change from fitbounds
    change()
    if (props.animation) {
      const options = Object.assign({}, props.animation, val)
      map.value.easeTo(options)
    } else {
      map.value.jumpTo(val)
    }
  }
})

// move from bounds change
watch(() => props.bounds, val => {
  if (map.value && val) {
    const options = Object.assign({},
      camera,
      props.animation,
      props.fitBoundsOptions
    )
    if (!options.duration) options.duration = 0
    delete options.center
    delete options.zoom
    map.value.fitBounds(val, options)
    // update camera after the fitbounds
    change(updateCamera, options.duration)
  }
})

// watch map options that can be update on the instance
watch(() => props.tiles, val => { if (map.value) map.value.setStyle(val) })
watch(() => props.minZoom, val => { if (map.value) map.value.setMinZoom(val) })
watch(() => props.maxZoom, val => { if (map.value) map.value.setMaxZoom(val) })
watch(() => props.minPitch, val => { if (map.value) map.value.setMinPitch(val) })
watch(() => props.maxPitch, val => { if (map.value) map.value.setMaxPitch(val) })
watch(() => props.maxBounds, val => { if (map.value) map.value.setMaxBounds(val) })
watch(() => props.renderWorldCopies, val => { if (map.value) map.value.setRenderWorldCopies(val) })
watch(() => props.transformRequest, val => { if (map.value) map.value.setTransformRequest(val) })
watch(() => props.pixelRatio, val => { if (map.value) map.value.setPixelRatio(val) })
watch(() => props.lang, val => { if (map.value) setLang(val, map) })

// event handlers
let handlers = {
  load: () => {
    load.value = true
    emit('load', map.value)
    if (props.lang) setLang(props.lang, map)
  },
  click: e => {
    // avoid original click event to bubble twice
    if (e.originalEvent) e.originalEvent.cancelBubble = true
    emit('click', e)
  },
  moveend: e => {
    if (e.originalEvent && e.originalEvent.isTrusted) {
      change(updateCamera) // update camera when user pan
    }
    emit('moveend', e)
  }
}

// init
onMounted(() => {
  map.value = new Map(options.value)
  // custom prop
  if (props.padding) map.value.setPadding(props.padding)

  // events
  map.value.on('load', handlers['load'])
  map.value.on('click', handlers['click'])
  map.value.on('moveend', handlers['moveend'])

  // merge handlers from attributes
  handlers = Object.assign(handlers, defineHandlers(eventsMap, map))
})

// clean
onUnmounted(() => {
  removeHandlers(handlers, map)
  map.value.remove()
})

// expose to children and parent
provide('map', map)
defineExpose({ map })
</script>

<style lang="scss">
.map-libre {
  height: 100%;
}
</style>
